#include<stdio.h>
#include<conio.h>

int cutPoints [100];
int dp [100] [100];
int cutter(int,int);
void init(int); 

int main ()
{
	   int length,numberOFCutPoint;

	   printf("Enter Length : ");
	   scanf("%d",&length);
	   printf("Enter Number Of CutPoint : ");
	   scanf ("%d", &numberOFCutPoint);      
	   for ( int i = 1; i <= numberOFCutPoint; i++ )
	       scanf ("%d", &cutPoints [i]);

	   cutPoints [0] = 0;
	   cutPoints [numberOFCutPoint + 1] = length;
	   init (numberOFCutPoint);      
	   printf ("The Minimum Cutting Is %d.\n", cutter (0, numberOFCutPoint + 1));

	   getch();
	   return 0;
}

int cutter (int start, int end)
{
    if ( end - start == 1 )
		return 0;

    if ( dp [start] [end] != -1 )
        return dp [start] [end];
	
    int cost = 0;

    int minimum = cutter ( start , start + 1 ) + cutter ( start + 1 , end ) + cutPoints [end] - cutPoints [start];
    for ( int i = start + 2 ; i < end ; i++ ) {
    
		cost = cutter (start, i) + cutter (i, end) + cutPoints [end] - cutPoints [start];
        if ( cost < minimum ){
			minimum = cost;
		}
	}
	
    return dp [start] [end] = minimum;

}

 

void init (int n)
{
	n+=3;
    for ( int i = 0 ; i < n ; i++ ) {
      for ( int j = i ; j < n ; j++ )
            dp [i] [j] = -1;
    }
}